<script>
import axios from 'axios'
import { StreamBarcodeReader } from 'vue-barcode-reader'

export default {
  components: {
    StreamBarcodeReader
  },
  methods: {
    async onDecode(text) {
      await axios.post(`http://localhost:3000/orders/${this.$route.params.id}/product/${text}`)
      const data = await this.loadData(this.$route.params.id)
      this.products = data.products
      this.item = data.item
      this.showQrCode = false
    },
    onClick() {
      this.showQrCode = !this.showQrCode
    },
    async loadData(orderId) {
        const res = await axios.get(`http://localhost:3000/orders/${orderId}`)
        const item = res.data
        const res2 = await axios.get('http://localhost:3000/products')
        const products = item.products?.map((p) => ({
            ...res2.data.find((d) => d.key === p.key),
            ...p
        })) || []
        return {
            item,
            products
        }
    }
  },
  data() {
    return {
      showQrCode: false,
      item: {},
      products: []
    }
  },
  async created() {
    try {
      const data = await this.loadData(this.$route.params.id)
      this.products = data.products
      this.item = data.item
    } catch (error) {
      console.log(error)
    }
  }
}
</script>

<template>
  <h1>Detail order : {{ item.title }}</h1>
  <button v-on:click="onClick">Add product</button>

  <StreamBarcodeReader
    v-if="showQrCode"
    @decode="onDecode"
  ></StreamBarcodeReader>
  <table>
    <thead>
      <tr>
        <th>Title</th>
        <th>key</th>
        <th>Number of product</th>
        <th>Weight</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="product of products" :key="product.id">
        <td>{{ product.title }}</td>
        <td>{{ product.key }}</td>
        <td>{{ product.quantity }}</td>
        <td>{{ product.quantity * product.weight }}</td>
      </tr>
    </tbody>
  </table>
</template>
